#include <cmath>
#include "mathops.h"

Z gcd(Z a, Z b) {
  Z rem;

  if (a == 0 && b == 0)
    return 0;

  a = abs(a);
  b = abs(b);

  // Euclidean algorithm:

  while (a != 0) {
    rem = b % a;
    b = a;
    a = rem;
  }
  return b;
}

Z lcm(const Z &a, const Z &b) {
  return a * b / gcd(a, b);
}

